#ifndef  _MIL1553UDx_DRIVER_API_H
#define _MIL1553UDx_DRIVER_API_H

	const char MIL1553UDx_DRIVER_MASKNAME[] = "\\\\.\\PCIe1553UDx%d";

	#define MIL1553UDx                      0xA460
	#define MIL1553UDx_LIB_NUMOF_RETRIES	20

	#define PCIe_1553UD		1
	#define PCIe_1553UD2	2
	#define PCIe_1553UD4	4

	#define NONE		0
	#define BUSA		1
	#define BUSB		2
	#define BOTH		3

	#define BM_A		0
	#define	BC			1
	#define	RT			2
	#define	BM_NA		3

	#define CTRL_REG_PCI_1CH	0x2000
	#define CTRL_REG_PCI_2CH	0x4000
	#define CTRL_REG_PCI_3CH	0x6000
	#define CTRL_REG_PCI_4CH	0x8000

	#define BC_CONF_REG_PCI_1CH	0x2008
	#define BC_CONF_REG_PCI_2CH	0x4008
	#define BC_CONF_REG_PCI_3CH	0x6008
	#define BC_CONF_REG_PCI_4CH	0x8008

	#define BC_INSTR_REG_PCI_1CH	0x18000
	#define BC_INSTR_REG_PCI_2CH	0x28000
	#define BC_INSTR_REG_PCI_3CH	0x38000
	#define BC_INSTR_REG_PCI_4CH	0x48000

	#define BC_OPER_REG_PCI_1CH	0x1C000
	#define BC_OPER_REG_PCI_2CH	0x2C000
	#define BC_OPER_REG_PCI_3CH	0x3C000
	#define BC_OPER_REG_PCI_4CH	0x4C000

	#define BC_DATA_REG_PCI_1CH	0x10000
	#define BC_DATA_REG_PCI_2CH	0x20000
	#define BC_DATA_REG_PCI_3CH	0x30000
	#define BC_DATA_REG_PCI_4CH	0x40000

	/////////////////////////////////////////////////////////////////////////////
	//IOCTLs
	 #define IOCTL_MIL1553UDx_GET_DEVICE_VER \
		CTL_CODE(MIL1553UDx , 0x903, METHOD_BUFFERED, FILE_WRITE_ACCESS)
	#define IOCTL_MIL1553UDx_GET_NBLOCK_RAW_DMA \
		CTL_CODE(MIL1553UDx , 0x905, METHOD_BUFFERED, FILE_READ_ACCESS)
	#define IOCTL_MIL1553UDx_READ_DMA_CH_DATA_BLOCKS \
		CTL_CODE(MIL1553UDx , 0x908, METHOD_BUFFERED, FILE_READ_ACCESS)
	 #define IOCTL_MIL1553UDx_READ_REG    \
		CTL_CODE(MIL1553UDx , 0x909, METHOD_BUFFERED, FILE_ANY_ACCESS) 
	#define IOCTL_MIL1553UDx_WRITE_BAR \
		CTL_CODE(MIL1553UDx , 0x90B, METHOD_BUFFERED, FILE_WRITE_ACCESS) 
	#define IOCTL_MIL1553UDx_WRITE_REG  \
		CTL_CODE(MIL1553UDx , 0x90C, METHOD_BUFFERED, FILE_ANY_ACCESS)

	/////////////////////////////////////////////////////////////////////////////
	//Structs
	typedef struct{
		UINT32 nAddr;
		UINT32 nSubAddr;
		UINT32 nRcvTr;
		UINT32 nDWCount;
		UINT32 nRptTime;
		UINT32 nRptCount;
		UINT32 nFormat;
	} WR_MIL1553UDx;

	//IOCTL_MIL1553UDx_GET_DEVICE_VER
	typedef struct _MIL1553UDx_GET_REV_OUT{
		UINT32 m_nRev;
		UINT32 m_nType;
	} MIL1553UDx_GET_REV_OUT;

	//IOCTL_MIL1553UDx_GET_NBLOCK_RAW_DMA
	typedef struct _MIL1553UDx_GET_NBLOCK_DMA_OUT{
		UINT32 m_nBlock;
	} MIL1553UDx_GET_NBLOCK_DMA_OUT;

	typedef struct _MIL1553UDx_GET_NBLOCK_DMA_IN{
		UINT32 m_nCh;
	} MIL1553UDx_GET_NBLOCK_DMA_IN;

	// IOCTL_MIL1553UDx_READ_DMA_CH_DATA_BLOCKS
	typedef struct _MIL1553UDx_READ_DMA_BLOCKS_CH_IN{
		UINT32 m_nBlocks;        // Size (in bytes)
		UINT32 m_nCh;            // Number of channel which should be read 
	} MIL1553UDx_READ_DMA_BLOCKS_CH_IN;

	//IOCTL_MIL1553UDx_READ_REG
	typedef struct _MIL1553UDx_READ_REG_IN{
	  int m_nAdress;
	} MIL1553UDx_READ_REG_IN;

	// IOCTL_MIL1553UDx_WRITE_REG
	typedef struct _MIL1553UDx_WRITE_REG_IN{
	  int m_nAdress;
	  int m_nData;
	} MIL1553UDx_WRITE_REG_IN;

	// IOCTL_MIL1553DEV_WRITE_BAR
	typedef struct _MIL1553UDx_WRITE_BAR_IN{
	  UINT32 m_nBar;
	  UINT32 m_nOffset;      // Offset of data (in bytes)
	  UINT32 m_nSize;        // Size (in bytes)
	  UINT8 m_Data[0];       // array of bytes
	} MIL1553UDx_WRITE_BAR_IN;

	#ifndef _MIL1553_STD_DRIVER_API
	#define _MIL1553_STD_DRIVER_API

	#ifndef ASSERT // if MFC is not used
		#include <assert.h>
		#define ASSERT assert
	#endif

	#define CTL_CODE(DeviceType, Function, Method, Access) (                		\
		((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) )

	#define METHOD_BUFFERED			0
	#define METHOD_IN_DIRECT		1
	#define METHOD_OUT_DIRECT		2
	#define METHOD_NEITHER			3

	#define FILE_ANY_ACCESS			0
	#define FILE_READ_ACCESS		( 0x0001 )    // file & pipe
	#define FILE_WRITE_ACCESS		( 0x0002 )    // file & pipe

	#endif	//_MIL1553_STD_DRIVER_API

#endif	//_MIL1553UDx_DRIVER_API_H