// 1553UDx.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "windows.h"
#include "MIL1553UDxDevice.h"


typedef UINT (CALLBACK* LPDEVICE_OPEN)(UINT32, HANDLE *);
typedef UINT (CALLBACK* LPDEVICE_CLOSE)(HANDLE);
typedef UINT (CALLBACK* LPGET_DEVICE_TYPE)(HANDLE);
typedef UINT (CALLBACK* LPINIT_MIL1553)(HANDLE, UINT32, UINT32, UINT32);
typedef UINT (CALLBACK* LPSTART_STOP)(HANDLE, UINT32, BOOL);
typedef UINT (CALLBACK* LPWR_FRM)(HANDLE, UINT32, WR_MIL1553UDx, UINT32 *);
typedef UINT (CALLBACK* LPRD_FRM)(HANDLE, UINT32, UINT32, UINT32, UINT32, UINT32 *, void *);


int _tmain(int argc, _TCHAR* argv[]){

	HANDLE hDevice, hDevice1, hDevice2;
	HINSTANCE hDLL;					// Handle to DLL
	LPDEVICE_OPEN lpDEVICE_OPEN;    // Function pointer
	LPDEVICE_CLOSE lpDEVICE_CLOSE;
	LPGET_DEVICE_TYPE lpGET_DEVICE_TYPE;
	LPINIT_MIL1553 lpINIT_MIL1553;
	LPSTART_STOP lpSTART_STOP;
	LPWR_FRM lpWR_FRM;
	LPRD_FRM lpRD_FRM;
	UINT32 pData[32], nErr, nCh, NoResp, i, nAddr, nSubAddr, nRcvTr, nStatus;
	WR_MIL1553UDx Str;
	
	Str.nAddr = 2,		// 
	Str.nSubAddr = 1,	// 
	Str.nRcvTr = 0,		//  = 1,  = 0
	Str.nRptTime = 0xff,
	Str.nRptCount = 1,	//0 - 
	Str.nFormat = 1,	//2 -  , 1 -  
	Str.nDWCount = 32;
	for (i=0; i<32; i++)
		pData[i] = 2;
	
	hDLL = LoadLibrary("PCIe1553UDx.dll");
	if (hDLL == NULL){
		printf("Error opening dll file.\n");
		scanf("%x");
		return 0;
	}

	lpDEVICE_OPEN = (LPDEVICE_OPEN)GetProcAddress(hDLL, "DEVICE_OPEN");
	lpDEVICE_CLOSE = (LPDEVICE_CLOSE)GetProcAddress(hDLL, "DEVICE_CLOSE");
	lpGET_DEVICE_TYPE = (LPGET_DEVICE_TYPE)GetProcAddress(hDLL, "GetDeviceType");
	lpINIT_MIL1553 = (LPINIT_MIL1553)GetProcAddress(hDLL, "INIT_MIL1553");
	lpSTART_STOP = (LPSTART_STOP)GetProcAddress(hDLL, "MIL1553_START_STOP");
	lpWR_FRM = (LPWR_FRM)GetProcAddress(hDLL, "WR_MIL1553_FRM");
	lpRD_FRM = (LPRD_FRM)GetProcAddress(hDLL, "READ_MIL1553");

	if (!lpDEVICE_CLOSE &&  !lpDEVICE_OPEN && !lpGET_DEVICE_TYPE && !lpINIT_MIL1553){
		// handle the error
		FreeLibrary(hDLL);
		printf("Error getting func.\n");
		scanf("%x");
		return 0;
	}

	if (!lpDEVICE_OPEN(0, &hDevice)){
		printf("Error opening device.\n");
		if (hDevice == INVALID_HANDLE_VALUE)
			printf("INVALID_HANDLE_VALUE.\n");
		scanf("%x");
		return 0;
	}
	else
		printf("Device has been opened.\n");

	NoResp = 110; nCh = 2;
	nErr = lpINIT_MIL1553(hDevice, nCh, BC, NoResp);
	if (nErr != 1){
		printf("Error initialization device. Err = %d\n");
		scanf("%x");
		return 0;
	}
	else
		printf("Device has been initializated.\n");

	nErr = lpSTART_STOP(hDevice, nCh, TRUE);
	if (nErr != 1){
		printf("Error start working device. Err = %d\n");
		scanf("%x");
		return 0;
	}
	else
		printf("Device has been started.\n");

	nErr = lpWR_FRM(hDevice, nCh, Str, pData);
	if (nErr != 1){
		printf("Error sending data. Err = %d\n");
		scanf("%x");
		return 0;
	}
	else
		printf("Data has been send.\n");

	nAddr=2; nSubAddr=1; nRcvTr=0;

	nErr = lpRD_FRM(hDevice, nCh, nAddr, nSubAddr, nRcvTr, &nStatus, pData);
	if (nErr != 1){
		printf("Error reading DMA data. Err = %d\n");
		scanf("%x");
		return 0;
	}
	else{
		if (nStatus)
			printf("Errors in DMA data block. Status = %d \n", nStatus);
		else{
			printf("DMA data block \n");
			for(i=0; i<32; i++)
				printf("0x%x\n", pData[i]);
		}			
	}

	lpDEVICE_CLOSE(hDevice);
	printf("Device has been closed.\n");
	
	FreeLibrary(hDLL);
	scanf("%x");
	return 0;
}